#!/usr/bin/env python3

from math import floor
from sys import argv

notes = ["A", "Bb", "B", "C", "Db", "D", "Eb", "E", "F", "Gb", "G", "Ab"]

C1 = -12*6 # A4 is 0

a = []
for i in range(12*8):
    a.append(440 * (pow(2, (i+C1)/12))) # from https://pages.mtu.edu/~suits/NoteFreqCalcs.html

r = []
for f in a:
    reg = 2048 - (3072000 / 32 / f) # from http://daifukkat.su/docs/wsman/#snd_pitch
    # reg = (3.072 * 10e6)  / ((2048 - f) * 32 ) # from https://github.com/TwitchPlaysPokemon/tpp-BizHawk2/blob/master/wonderswan/wstech24.txt ??? is wrong
    r.append(reg)

def getNoteName(i):
    return notes[i%12]+str(floor((i-24)/12))

if argv[-1] == '-c':
    print("#ifndef _NOTES_H_")
    print("#define _NOTES_H_")
    print("int note_values[] = {")
    for i in range(len(a)):
        print("   ", hex(round(r[i]))+",", "/*", i, getNoteName(i), "*/")
    print("}")
    print("#endif")
else:
    print("; these are the actual values to write to the frequency registers")
    print("; practical note values are probably about A1 to A6")
    print("global _note_values_in_rom")
    print("_note_values_in_rom:")
    for i in range(len(a)):
        print("dw ", hex(round(r[i])), "; ", i, a[i], getNoteName(i))
    print("_note_values_in_rom_end:")