#!/usr/bin/env python

import re

wswanhf = open("WonderSwan.h", "rt")
wshl = wswanhf.readlines()


outf = open("out.h", "wt")
outf.write("""
#ifndef ___OUT_H
#define ___OUT_H

void outb_dx(unsigned short port, unsigned char value);

#pragma aux outb_dx = \\
"out dx, al" \\
parm [ dx ] [ al ];

void outw_dx(unsigned short port, unsigned short value);

#pragma aux outw_dx = \\
"out dx, ax" \\
parm [ dx ] [ ax ];

unsigned char inb_dx(unsigned short port);

#pragma aux inb_dx = \\
"in al, dx" \\
parm [ dx ];

#define outb(port,value)\\
{\\
    _asm mov al, value \\
    _asm out port, al \\
};

// sadly, have not found a way to have an out(a,b) macro emit just "mov al, b \\n  out b, al"
""")

for i in range(256):
    port = f'{i:0{2}x}' 
    outf.write(f"""
void outb_{port}(unsigned char value);

#pragma aux outb_{port} = \\
"out 0x{port}, al" \\
parm [ al ];

void outw_{port}(unsigned short value);

#pragma aux outw_{port} = \\
"out 0x{port}, ax" \\
parm [ ax ];
    """)

defre = re.compile(r"^#define\s(IO_[A-Za-z0-9_]+)\s+0x([0-9a-fA-F][0-9a-fA-F])")
defwre = re.compile(r"^#define\s(IOw_[A-Za-z0-9_]+)\s+0x([0-9a-fA-F][0-9a-fA-F])")
for line in wshl:
    m = defre.match(line)
    mw = defwre.match(line)
    if m:
        port = m.group(1)
        value = m.group(2).lower()
        outf.write(f"""
#define outb_{port} outb_{value}

""")
    if mw:
        port = mw.group(1)
        value = mw.group(2).lower()
        outf.write(f"""
 #define outw_{port} outw_{value}
 
 """)


outf.write("""

#endif

""")
